Index: /LMDZ5/branches/testing/libf/phylmd/phyredem.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phyredem.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/phyredem.F90	(revision 2542)
@@ -9,14 +9,16 @@
   USE fonte_neige_mod,  ONLY : fonte_neige_final
   USE pbl_surface_mod,  ONLY : pbl_surface_final
-  USE phys_state_var_mod, ONLY: radpas, zmasq, pctsrf, ftsol, falb_dir, &
+  USE phys_state_var_mod, ONLY: radpas, zmasq, pctsrf, ftsol, falb_dir,      &
                                 falb_dif, qsol, fevap, radsol, solsw, sollw, &
-                                sollwdown, rain_fall, snow_fall, z0m, z0h, &
-                                agesno, zmea, zstd, zsig, zgam, zthe, zpic, &
-                                zval, rugoro, t_ancien, q_ancien, u_ancien, &
-                                v_ancien, clwcon, rnebcon, ratqs, pbl_tke, &
-                                wake_delta_pbl_tke, zmax0, f0, sig1, w01, &
-                                wake_deltat, wake_deltaq, wake_s, wake_cstar, &
-                                wake_pe, wake_fip, fm_therm, entr_therm, &
-                                detr_therm, Ale_bl, Ale_bl_trig, Alp_bl, &
+                                sollwdown, rain_fall, snow_fall, z0m, z0h,   &
+                                agesno, zmea, zstd, zsig, zgam, zthe, zpic,  &
+                                zval, rugoro, t_ancien, q_ancien,            &
+                                prw_ancien, prlw_ancien, prsw_ancien,        &
+                                ql_ancien, qs_ancien,  u_ancien,             &
+                                v_ancien, clwcon, rnebcon, ratqs, pbl_tke,   &
+                                wake_delta_pbl_tke, zmax0, f0, sig1, w01,    &
+                                wake_deltat, wake_deltaq, wake_s, wake_cstar,&
+                                wake_pe, wake_fip, fm_therm, entr_therm,     &
+                                detr_therm, Ale_bl, Ale_bl_trig, Alp_bl,     &
                                 du_gwd_rando, du_gwd_front
   USE geometry_mod, ONLY : longitude_deg, latitude_deg
@@ -201,7 +203,17 @@
   CALL put_field("QANCIEN", "QANCIEN", q_ancien)
 
-  CALL put_field("UANCIEN", "", u_ancien)
-
-  CALL put_field("VANCIEN", "", v_ancien)
+  CALL put_field("QLANCIEN", "QLANCIEN", ql_ancien)
+
+  CALL put_field("QSANCIEN", "QSANCIEN", qs_ancien)
+
+  CALL put_field("PRWANCIEN", "PRWANCIEN", prw_ancien)
+
+  CALL put_field("PRLWANCIEN", "PRLWANCIEN", prlw_ancien)
+
+  CALL put_field("PRSWANCIEN", "PRSWANCIEN", prsw_ancien)
+
+  CALL put_field("UANCIEN", "UANCIEN", u_ancien)
+
+  CALL put_field("VANCIEN", "VANCIEN", v_ancien)
 
   CALL put_field("CLWCON", "Eau liquide convective", clwcon)
Index: /LMDZ5/branches/testing/libf/phylmd/phys_cal_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_cal_mod.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_cal_mod.F90	(revision 2542)
@@ -15,5 +15,5 @@
   INTEGER,SAVE :: year_len      ! number of days in the current year
 !$OMP THREADPRIVATE(year_len)
-  REAL,SAVE    :: hour
+  REAL,SAVE    :: hour         ! seconds elapsed (in the current day) since midnight
 !$OMP THREADPRIVATE(hour)
   REAL,SAVE    :: jD_1jan
Index: /LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90	(revision 2542)
@@ -21,4 +21,8 @@
       REAL, SAVE, ALLOCATABLE :: d_t_dyn(:,:), d_q_dyn(:,:)
       !$OMP THREADPRIVATE(d_t_dyn, d_q_dyn)
+      REAL, SAVE, ALLOCATABLE :: d_ql_dyn(:,:), d_qs_dyn(:,:)
+      !$OMP THREADPRIVATE(d_ql_dyn, d_qs_dyn)
+      REAL, SAVE, ALLOCATABLE :: d_q_dyn2d(:), d_ql_dyn2d(:), d_qs_dyn2d(:)
+      !$OMP THREADPRIVATE(d_q_dyn2d, d_ql_dyn2d, d_qs_dyn2d)
       REAL, SAVE, ALLOCATABLE :: d_u_dyn(:,:), d_v_dyn(:,:)
       !$OMP THREADPRIVATE(d_u_dyn, d_v_dyn)
@@ -133,4 +137,6 @@
       !$OMP THREADPRIVATE(ZFSDN0,ZFSUP0)
 !
+      REAL, SAVE, ALLOCATABLE :: stratomask(:,:) 
+      !$OMP THREADPRIVATE(stratomask) 
       REAL, SAVE, ALLOCATABLE :: tausum_aero(:,:,:) 
       !$OMP THREADPRIVATE(tausum_aero) 
@@ -255,6 +261,6 @@
       REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: JrNt
 !$OMP THREADPRIVATE(JrNt)
-      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: dthmin, evap, fder, plcl, plfc, prw
-!$OMP THREADPRIVATE(dthmin, evap, fder, plcl, plfc, prw)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: dthmin, evap, fder, plcl, plfc, prw, prlw, prsw
+!$OMP THREADPRIVATE(dthmin, evap, fder, plcl, plfc, prw, prlw, prsw)
       REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zustar, zu10m, zv10m, rh2m
 !$OMP THREADPRIVATE(zustar, zu10m, zv10m, rh2m)
@@ -277,6 +283,8 @@
       REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zxfluxlat, zxtsol, snow_lsc, zxfqfonte
 !$OMP THREADPRIVATE(zxfluxlat, zxtsol, snow_lsc, zxfqfonte)
-      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zxqsurf, rain_lsc
-!$OMP THREADPRIVATE(zxqsurf, rain_lsc)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zxrunofflic
+!$OMP THREADPRIVATE(zxrunofflic)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zxqsurf, rain_lsc, rain_num
+!$OMP THREADPRIVATE(zxqsurf, rain_lsc, rain_num)
 !
 !jyg+nrlmd<
@@ -401,4 +409,6 @@
       allocate(tr_seri(klon,klev,nbtr))
       allocate(d_t_dyn(klon,klev),d_q_dyn(klon,klev))
+      allocate(d_ql_dyn(klon,klev),d_qs_dyn(klon,klev))
+      allocate(d_q_dyn2d(klon),d_ql_dyn2d(klon),d_qs_dyn2d(klon))
       allocate(d_u_dyn(klon,klev),d_v_dyn(klon,klev))
       allocate(d_tr_dyn(klon,klev,nbtr))                   !RomP
@@ -455,4 +465,5 @@
 !      allocate(tausum_aero(klon,nwave,naero_spc))
 !      allocate(tau3d_aero(klon,klev,nwave,naero_spc)) 
+      allocate(stratomask(klon,klev))
 !--correction mini bug OB
       allocate(tausum_aero(klon,nwave,naero_tot))
@@ -521,5 +532,5 @@
       ALLOCATE(JrNt(klon))
       ALLOCATE(dthmin(klon), evap(klon), fder(klon), plcl(klon), plfc(klon))
-      ALLOCATE(prw(klon), zustar(klon), zu10m(klon), zv10m(klon), rh2m(klon))
+      ALLOCATE(prw(klon), prlw(klon), prsw(klon), zustar(klon), zu10m(klon), zv10m(klon), rh2m(klon))
       ALLOCATE(s_lcl(klon))
       ALLOCATE(s_pblh(klon), s_pblt(klon), s_therm(klon))
@@ -534,5 +545,7 @@
       ALLOCATE(zxfqcalving(klon), zxfluxlat(klon))
       ALLOCATE(zxtsol(klon), snow_lsc(klon), zxfqfonte(klon), zxqsurf(klon))
+      ALLOCATE(zxrunofflic(klon))
       ALLOCATE(rain_lsc(klon))
+      ALLOCATE(rain_num(klon))
 !
       ALLOCATE(sens_x(klon), sens_w(klon))
@@ -615,4 +628,6 @@
       deallocate(tr_seri)
       deallocate(d_t_dyn,d_q_dyn)
+      deallocate(d_ql_dyn,d_qs_dyn)
+      deallocate(d_q_dyn2d,d_ql_dyn2d,d_qs_dyn2d)
       deallocate(d_u_dyn,d_v_dyn)
       deallocate(d_tr_dyn)                      !RomP
@@ -658,4 +673,5 @@
       deallocate(topsw0_aero,solsw0_aero)
       deallocate(topswcf_aero,solswcf_aero)
+      deallocate(stratomask) 
       deallocate(tausum_aero) 
       deallocate(tau3d_aero) 
@@ -725,5 +741,5 @@
       DEALLOCATE(cldljn, cldmjn, cldhjn, cldtjn, JrNt)
       DEALLOCATE(dthmin, evap, fder, plcl, plfc)
-      DEALLOCATE(prw, zustar, zu10m, zv10m, rh2m, s_lcl)
+      DEALLOCATE(prw, prlw, prsw, zustar, zu10m, zv10m, rh2m, s_lcl)
       DEALLOCATE(s_pblh, s_pblt, s_therm)
 !
@@ -736,6 +752,8 @@
       DEALLOCATE(uq, ve, vq, zxffonte)
       DEALLOCATE(zxfqcalving, zxfluxlat)
+      DEALLOCATE(zxrunofflic)
       DEALLOCATE(zxtsol, snow_lsc, zxfqfonte, zxqsurf)
       DEALLOCATE(rain_lsc)
+      DEALLOCATE(rain_num)
 !
       DEALLOCATE(sens_x, sens_w)
Index: /LMDZ5/branches/testing/libf/phylmd/phys_output_ctrlout_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 2542)
@@ -154,4 +154,6 @@
   TYPE(ctrl_out), SAVE :: o_plul = ctrl_out((/ 1, 1, 1, 10, 10, 10, 11, 11, 11 /), &
     'plul', 'Large-scale Precip.', 'kg/(s*m2)', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_plun = ctrl_out((/ 1, 1, 1, 10, 10, 10, 11, 11, 11 /), &
+    'plun', 'Numerical Precip.', 'kg/(s*m2)', (/ ('', i=1, 9) /))
   TYPE(ctrl_out), SAVE :: o_pluc = ctrl_out((/ 1, 1, 1, 10, 5, 10, 11, 11, 11 /), &
     'pluc', 'Convective Precip.', 'kg/(s*m2)', (/ ('', i=1, 9) /))
@@ -160,4 +162,22 @@
   TYPE(ctrl_out), SAVE :: o_evap = ctrl_out((/ 1, 1, 10, 10, 10, 10, 11, 11, 11 /), &
     'evap', 'Evaporat', 'kg/(s*m2)', (/ ('', i=1, 9) /))
+
+  TYPE(ctrl_out), SAVE :: o_sens_prec_liq_oce = ctrl_out((/ 5, 5, 10, 10, 5, 10, 11, 11, 11 /), &
+    'sens_rain_oce', 'Sensible heat flux of liquid prec. over ocean', 'W/m2', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_sens_prec_liq_sic = ctrl_out((/ 5, 5, 10, 10, 5, 10, 11, 11, 11 /), &
+    'sens_rain_sic', 'Sensible heat flux of liquid prec. over seaice', 'W/m2', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_sens_prec_sol_oce = ctrl_out((/ 5, 5, 10, 10, 5, 10, 11, 11, 11 /), &
+    'sens_snow_oce', 'Sensible heat flux of solid prec. over ocean', 'W/m2', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_sens_prec_sol_sic = ctrl_out((/ 5, 5, 10, 10, 5, 10, 11, 11, 11 /), &
+    'sens_snow_sic', 'Sensible heat flux of solid prec. over seaice', 'W/m2', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_lat_prec_liq_oce = ctrl_out((/ 5, 5, 10, 10, 5, 10, 11, 11, 11 /), &
+    'lat_rain_oce', 'Latent heat flux of liquid prec. over ocean', 'W/m2', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_lat_prec_liq_sic = ctrl_out((/ 5, 5, 10, 10, 5, 10, 11, 11, 11 /), &
+    'lat_rain_sic', 'Latent heat flux of liquid prec. over seaice', 'W/m2', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_lat_prec_sol_oce = ctrl_out((/ 5, 5, 10, 10, 5, 10, 11, 11, 11 /), &
+    'lat_snow_oce', 'Latent heat flux of solid prec. over ocean', 'W/m2', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_lat_prec_sol_sic = ctrl_out((/ 5, 5, 10, 10, 5, 10, 11, 11, 11 /), &
+    'lat_snow_sic', 'Latent heat flux of solid prec. over seaice', 'W/m2', (/ ('', i=1, 9) /))
+
 
   TYPE(ctrl_out), SAVE, DIMENSION(4) :: o_evap_srf     = (/ &
@@ -271,4 +291,6 @@
   TYPE(ctrl_out), SAVE :: o_fqfonte = ctrl_out((/ 1, 10, 10, 10, 10, 10, 11, 11, 11 /), &
     'fqfonte', 'Land ice melt', 'kg/m2/s', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_runofflic = ctrl_out((/ 1, 10, 10, 10, 10, 10, 11, 11, 11 /), &
+    'runofflic', 'Land ice melt to ocean', 'kg/m2/s', (/ ('', i=1, 9) /))
   TYPE(ctrl_out), SAVE :: o_taux = ctrl_out((/ 1, 10, 10, 10, 10, 10, 11, 11, 11 /), &
     'taux', 'Zonal wind stress', 'Pa', (/ ('', i=1, 9) /))
@@ -449,4 +471,8 @@
   TYPE(ctrl_out), SAVE :: o_prw = ctrl_out((/ 1, 1, 10, 10, 10, 10, 11, 11, 11 /), &
     'prw', 'Precipitable water', 'kg/m2', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_prlw = ctrl_out((/ 1, 1, 10, 10, 10, 10, 11, 11, 11 /), &
+    'prlw', 'Precipitable liquid water', 'kg/m2', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_prsw = ctrl_out((/ 1, 1, 10, 10, 10, 10, 11, 11, 11 /), &
+    'prsw', 'Precipitable solid water', 'kg/m2', (/ ('', i=1, 9) /))
   TYPE(ctrl_out), SAVE :: o_s_pblh = ctrl_out((/ 1, 10, 10, 10, 10, 10, 11, 11, 11 /), &
     's_pblh', 'Boundary Layer Height', 'm', (/ ('', i=1, 9) /))
@@ -842,7 +868,4 @@
        ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /),'OD550_'//name_aero_tau(14),       &
        "Aerosol Optical depth at 550 nm "//name_aero_tau(14),"14", (/ ('', i=1, 9) /)) /)
-  
-
-
 !
   TYPE(ctrl_out), SAVE :: o_tausumaero_lw = ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11 /), &
@@ -992,4 +1015,12 @@
   TYPE(ctrl_out), SAVE :: o_dqphy2d = ctrl_out((/ 2, 10, 10, 10, 10, 10, 11, 11, 11 /), &
     'dqphy2d', 'Physics dQ', '(kg/m2)/s', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_dqlphy = ctrl_out((/ 2, 10, 10, 10, 10, 10, 11, 11, 11 /), &
+    'dqlphy', 'Physics dQL', '(kg/kg)/s', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_dqlphy2d = ctrl_out((/ 2, 10, 10, 10, 10, 10, 11, 11, 11 /), &
+    'dqlphy2d', 'Physics dQL', '(kg/m2)/s', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_dqsphy = ctrl_out((/ 2, 10, 10, 10, 10, 10, 11, 11, 11 /), &
+    'dqsphy', 'Physics dQS', '(kg/kg)/s', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_dqsphy2d = ctrl_out((/ 2, 10, 10, 10, 10, 10, 11, 11, 11 /), &
+    'dqsphy2d', 'Physics dQS', '(kg/m2)/s', (/ ('', i=1, 9) /))
   TYPE(ctrl_out), SAVE :: o_pr_con_l = ctrl_out((/ 2, 10, 10, 10, 10, 10, 11, 11, 11 /), &
     'pr_con_l', 'Convective precipitation lic', ' ', (/ ('', i=1, 9) /))
@@ -1016,4 +1047,6 @@
   TYPE(ctrl_out), SAVE :: o_lcc3dstra = ctrl_out((/ 2,  6, 10, 10, 10, 10, 11, 11, 11 /), &
     'lcc3dstra', 'Stratiform cloud liquid fraction', '1', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_stratomask = ctrl_out((/ 2,  6, 10, 10, 10, 10, 11, 11, 11 /), &
+    'stratomask', 'Stratospheric fraction', '1', (/ ('', i=1, 9) /))
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
@@ -1071,4 +1104,12 @@
   TYPE(ctrl_out), SAVE :: o_dqdyn2d = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11 /), &
     'dqdyn2d', 'Dynamics dQ', '(kg/m2)/s', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_dqldyn = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11 /), &
+    'dqldyn', 'Dynamics dQL', '(kg/kg)/s', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_dqldyn2d = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11 /), &
+    'dqldyn2d', 'Dynamics dQL', '(kg/m2)/s', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_dqsdyn = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11 /), &
+    'dqsdyn', 'Dynamics dQS', '(kg/kg)/s', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_dqsdyn2d = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11 /), &
+    'dqsdyn2d', 'Dynamics dQS', '(kg/m2)/s', (/ ('', i=1, 9) /))
   TYPE(ctrl_out), SAVE :: o_dudyn = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11 /), &
     'dudyn', 'Dynamics dU', 'm/s2', (/ ('', i=1, 9) /))
@@ -1402,5 +1443,5 @@
        "inst(X)", "inst(X)", "inst(X)", "inst(X)", "inst(X)", "inst(X)"  /))
   TYPE(ctrl_out), SAVE :: o_vxq = ctrl_out((/ 11, 11, 11, 11, 11, 11, 6, 6, 6 /), &
-       'vq', 'vq', 'm/s * (kg/kg)', (/ "inst(X)", "inst(X)", "inst(X)", &
+       'vxq', 'vxq', 'm/s * (kg/kg)', (/ "inst(X)", "inst(X)", "inst(X)", &
        "inst(X)", "inst(X)", "inst(X)", "inst(X)", "inst(X)", "inst(X)"  /))                                                                                                    
   TYPE(ctrl_out), SAVE :: o_vxT = ctrl_out((/ 11, 11, 11, 11, 11, 11, 6, 6, 6 /), &
Index: /LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90	(revision 2542)
@@ -81,5 +81,6 @@
     INTEGER                               :: nlevSTD, radpas
     LOGICAL                               :: ok_mensuel, ok_journe, ok_hf, ok_instan
-    LOGICAL                               :: ok_LES,ok_ade,ok_aie,flag_aerosol_strat
+    LOGICAL                               :: ok_LES,ok_ade,ok_aie
+    INTEGER                               :: flag_aerosol_strat
     LOGICAL                               :: new_aod, aerosol_couple
     INTEGER, INTENT(IN)::  read_climoz ! read ozone climatology
@@ -255,5 +256,9 @@
      idayref = day_ref
      IF (klon_glo==1) THEN
-         CALL ymds2ju(annee_ref, 1, idayref, hour, zjulian)     !jyg
+       ! current_time (used to compute hour) is updated at the begining of
+       ! the physics; to set the correct outputs "initial time" we thus 
+       ! have to use (hour-dtphys).
+         CALL ymds2ju(annee_ref, 1, idayref, hour-pdtphys, zjulian)
+         print *,'phys_output_mod: annee,iday,hour,zjulian=',annee_ref,idayref, hour, zjulian
      ELSE
          CALL ymds2ju(annee_ref, 1, idayref, 0.0, zjulian)
Index: /LMDZ5/branches/testing/libf/phylmd/phys_output_var_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_output_var_mod.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_output_var_mod.F90	(revision 2542)
@@ -47,5 +47,7 @@
 
   ! swaero_diag : flag indicates if it is necessary to do calculation for some aerosol diagnostics
-  LOGICAL, SAVE                                :: swaero_diag=.FALSE.
+  !--OB: this needs to be set to TRUE by default and changed back to FALSE after first radiation call
+  !--    and corrected back to TRUE based on output requests
+  LOGICAL, SAVE                                :: swaero_diag=.TRUE.
   !$OMP THREADPRIVATE(swaero_diag)
 
@@ -74,4 +76,8 @@
   END TYPE ctrl_out
 
+  REAL, SAVE, ALLOCATABLE :: sens_prec_liq_o(:,:), sens_prec_sol_o(:,:)
+  REAL, SAVE, ALLOCATABLE :: lat_prec_liq_o(:,:), lat_prec_sol_o(:,:)
+ !$OMP THREADPRIVATE(sens_prec_liq_o, sens_prec_sol_o,lat_prec_liq_o,lat_prec_sol_o)
+
 CONTAINS
 
@@ -88,4 +94,11 @@
     allocate(snow_o(klon), zfra_o(klon))
     allocate(itau_con(klon))
+    allocate(sens_prec_liq_o(klon,2))
+    allocate(sens_prec_sol_o(klon,2))
+    allocate(lat_prec_liq_o(klon,2))
+    allocate(lat_prec_sol_o(klon,2))
+    sens_prec_liq_o = 0.0 ; sens_prec_sol_o = 0.0
+    lat_prec_liq_o = 0.0 ; lat_prec_sol_o = 0.0
+
     allocate (bils_ec(klon),bils_ech(klon),bils_tke(klon),bils_diss(klon),bils_kinetic(klon),bils_enthalp(klon),bils_latent(klon))
 
Index: /LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90	(revision 2542)
@@ -17,5 +17,5 @@
   SUBROUTINE phys_output_write(itap, pdtphys, paprs, pphis, &
        pplay, lmax_th, aerosol_couple,         &
-       ok_ade, ok_aie, ivap, new_aod, ok_sync, &
+       ok_ade, ok_aie, ivap, iliq, isol, new_aod, ok_sync, &
        ptconv, read_climoz, clevSTD, ptconvth, &
        d_t, qx, d_qx, zmasse, flag_aerosol, flag_aerosol_strat, ok_cdnc)
@@ -36,5 +36,5 @@
          o_wind10m, o_wind10max, o_gusts, o_sicf, &
          o_psol, o_mass, o_qsurf, o_qsol, &
-         o_precip, o_ndayrain, o_plul, o_pluc, &
+         o_precip, o_ndayrain, o_plul, o_pluc, o_plun, &
          o_snow, o_msnow, o_fsnow, o_evap, o_ep,o_epmax_diag, & ! epmax_cape
          o_tops, o_tops0, o_topl, o_topl0, &
@@ -50,5 +50,5 @@
          o_bils_ec,o_bils_ech, o_bils_tke, o_bils_kinetic, &
          o_bils_latent, o_bils_enthalp, o_sens, &
-         o_fder, o_ffonte, o_fqcalving, o_fqfonte, &
+         o_fder, o_ffonte, o_fqcalving, o_fqfonte, o_runofflic, &
          o_taux, o_tauy, o_snowsrf, o_qsnow, &
          o_snowhgt, o_toice, o_sissnow, o_runoff, &
@@ -67,5 +67,5 @@
          o_wbeff, o_cape_max, o_upwd, o_ep,o_epmax_diag, o_Ma, &
          o_dnwd, o_dnwd0, o_ftime_con, o_mc, &
-         o_prw, o_s_pblh, o_s_pblt, o_s_lcl, &
+         o_prw, o_prlw, o_prsw, o_s_pblh, o_s_pblt, o_s_lcl, &
          o_s_therm, o_uSTDlevs, o_vSTDlevs, &
          o_wSTDlevs, o_zSTDlevs, o_qSTDlevs, &
@@ -112,5 +112,5 @@
          o_swtoacf_zero, o_swsrfcf_zero, &
          o_topswai, o_solswai, o_scdnc, &
-         o_cldncl, o_reffclws, o_reffclwc, &
+         o_cldncl, o_reffclws, o_reffclwc, o_stratomask,&
          o_cldnvi, o_lcc, o_lcc3d, o_lcc3dcon, &
          o_lcc3dstra, o_reffclwtop, o_ec550aer, &
@@ -120,8 +120,10 @@
          o_zfull, o_zhalf, o_rneb, o_rnebjn, o_rnebcon, &
          o_rnebls, o_rhum, o_ozone, o_ozone_light, &
-         o_dtphy, o_dqphy, o_dqphy2d, o_albe_srf, o_z0m_srf, o_z0h_srf, &
+         o_dtphy, o_dqphy, o_dqphy2d, o_dqlphy, o_dqlphy2d, &
+         o_dqsphy, o_dqsphy2d, o_albe_srf, o_z0m_srf, o_z0h_srf, &
          o_ages_srf, o_snow_srf, o_alb1, o_alb2, o_tke, &
          o_tke_max, o_kz, o_kz_max, o_clwcon, &
-         o_dtdyn, o_dqdyn, o_dqdyn2d, o_dudyn, o_dvdyn, &
+         o_dtdyn, o_dqdyn, o_dqdyn2d, o_dqldyn, o_dqldyn2d, & 
+         o_dqsdyn, o_dqsdyn2d, o_dudyn, o_dvdyn, &
          o_dtcon, o_tntc, o_ducon, o_dvcon, &
          o_dqcon, o_dqcon2d, o_tnhusc, o_tnhusc, o_dtlsc, &
@@ -161,5 +163,9 @@
          o_dtr_sat, o_dtr_uscav, o_trac_cum, o_du_gwd_rando, o_dv_gwd_rando, &
          o_ustr_gwd_hines,o_vstr_gwd_hines,o_ustr_gwd_rando,o_vstr_gwd_rando, &
-         o_ustr_gwd_front,o_vstr_gwd_front
+         o_ustr_gwd_front,o_vstr_gwd_front, &
+         o_sens_prec_liq_oce, o_sens_prec_liq_sic, &
+         o_sens_prec_sol_oce, o_sens_prec_sol_sic, &
+         o_lat_prec_liq_oce, o_lat_prec_liq_sic, &
+         o_lat_prec_sol_oce, o_lat_prec_sol_sic
 
     USE phys_state_var_mod, only: pctsrf, paire_ter, rain_fall, snow_fall, &
@@ -193,6 +199,6 @@
          t2m_min_mon, t2m_max_mon, evap, &
          zu10m, zv10m, zq2m, zustar, zxqsurf, &
-         rain_lsc, snow_lsc, bils, sens, fder, &
-         zxffonte, zxfqcalving, zxfqfonte, fluxu, &
+         rain_lsc, rain_num, snow_lsc, bils, sens, fder, &
+         zxffonte, zxfqcalving, zxfqfonte, zxrunofflic, fluxu, &
          fluxv, zxsnow, qsnow, snowhgt, to_ice, &
          sissnow, runoff, albsol3_lic, evap_pot, &
@@ -201,5 +207,5 @@
          cldh, cldt, JrNt, cldljn, cldmjn, cldhjn, &
          cldtjn, cldq, flwp, fiwp, ue, ve, uq, vq, &
-         plcl, plfc, wbeff, upwd, dnwd, dnwd0, prw, &
+         plcl, plfc, wbeff, upwd, dnwd, dnwd0, prw, prlw, prsw, &
          s_pblh, s_pblt, s_lcl, s_therm, uwriteSTD, &
          vwriteSTD, wwriteSTD, phiwriteSTD, qwriteSTD, &
@@ -228,13 +234,12 @@
          toplwad_aero, toplwad0_aero, sollwad_aero, &
          sollwad0_aero, toplwai_aero, sollwai_aero, &
-         scdnc, cldncl, reffclws, reffclwc, cldnvi, &
+         scdnc, cldncl, reffclws, reffclwc, cldnvi, stratomask,&
          lcc, lcc3d, lcc3dcon, lcc3dstra, reffclwtop, &
          ec550aer, flwc, fiwc, t_seri, theta, q_seri, &
-!jyg<
-!!         ql_seri, zphi, u_seri, v_seri, omega, cldfra, &
          ql_seri, tr_seri, &
          zphi, u_seri, v_seri, omega, cldfra, &
-!>jyg
-         rneb, rnebjn, zx_rh, d_t_dyn, d_q_dyn, &
+         rneb, rnebjn, zx_rh, d_t_dyn,  & 
+         d_q_dyn,  d_ql_dyn, d_qs_dyn, &
+         d_q_dyn2d,  d_ql_dyn2d, d_qs_dyn2d, &
          d_u_dyn, d_v_dyn, d_t_con, d_t_ajsb, d_t_ajs, &
          d_u_ajs, d_v_ajs, &
@@ -256,5 +261,8 @@
          itau_con, nfiles, clef_files, nid_files, &
          zustr_gwd_hines, zvstr_gwd_hines,zustr_gwd_rando, zvstr_gwd_rando, &
-         zustr_gwd_front, zvstr_gwd_front                                   
+         zustr_gwd_front, zvstr_gwd_front,     &
+         sens_prec_liq_o, sens_prec_sol_o, lat_prec_liq_o, lat_prec_sol_o
+  
+
     USE ocean_slab_mod, only: tslab, slab_bils, slab_bilg, tice, seaice
     USE pbl_surface_mod, only: snow
@@ -288,5 +296,5 @@
 
     ! Input
-    INTEGER :: itap, ivap, read_climoz
+    INTEGER :: itap, ivap, iliq, isol, read_climoz
     INTEGER, DIMENSION(klon) :: lmax_th
     LOGICAL :: aerosol_couple, ok_sync
@@ -301,5 +309,5 @@
     REAL, DIMENSION(klon,klev,nqtot) :: qx, d_qx
     REAL, DIMENSION(klon, klev) :: zmasse
-    LOGICAL :: flag_aerosol_strat
+    INTEGER :: flag_aerosol_strat
     INTEGER :: flag_aerosol 
     LOGICAL :: ok_cdnc
@@ -440,4 +448,5 @@
        ENDIF
        CALL histwrite_phy(o_plul, zx_tmp_fi2d)
+       CALL histwrite_phy(o_plun, rain_num)
 
        IF (vars_defined) THEN
@@ -545,4 +554,5 @@
        CALL histwrite_phy(o_fqcalving, zxfqcalving)
        CALL histwrite_phy(o_fqfonte, zxfqfonte)
+       CALL histwrite_phy(o_runofflic, zxrunofflic)
        IF (vars_defined) THEN
           zx_tmp_fi2d=0.
@@ -618,4 +628,23 @@
 
        ENDDO
+
+       IF (vars_defined) zx_tmp_fi2d(1 : klon) = sens_prec_liq_o(1 : klon, 1)
+       CALL histwrite_phy(o_sens_prec_liq_oce, zx_tmp_fi2d)       
+       IF (vars_defined) zx_tmp_fi2d(1 : klon) = sens_prec_liq_o(1 : klon, 2)
+       CALL histwrite_phy(o_sens_prec_liq_sic, zx_tmp_fi2d)       
+       IF (vars_defined) zx_tmp_fi2d(1 : klon) = sens_prec_sol_o(1 : klon, 1)
+       CALL histwrite_phy(o_sens_prec_sol_oce, zx_tmp_fi2d)       
+       IF (vars_defined) zx_tmp_fi2d(1 : klon) = sens_prec_sol_o(1 : klon, 2)
+       CALL histwrite_phy(o_sens_prec_sol_sic, zx_tmp_fi2d)       
+
+       IF (vars_defined) zx_tmp_fi2d(1 : klon) = lat_prec_liq_o(1 : klon, 1)
+       CALL histwrite_phy(o_lat_prec_liq_oce, zx_tmp_fi2d)       
+       IF (vars_defined) zx_tmp_fi2d(1 : klon) = lat_prec_liq_o(1 : klon, 2)
+       CALL histwrite_phy(o_lat_prec_liq_sic, zx_tmp_fi2d)       
+       IF (vars_defined) zx_tmp_fi2d(1 : klon) = lat_prec_sol_o(1 : klon, 1)
+       CALL histwrite_phy(o_lat_prec_sol_oce, zx_tmp_fi2d)       
+       IF (vars_defined) zx_tmp_fi2d(1 : klon) = lat_prec_sol_o(1 : klon, 2)
+       CALL histwrite_phy(o_lat_prec_sol_sic, zx_tmp_fi2d)       
+
        DO nsrf=1,nbsrf+1
           CALL histwrite_phy(o_wstar(nsrf), wstar(1 : klon, nsrf))
@@ -671,4 +700,6 @@
        ENDIF !iflag_con .GE. 3
        CALL histwrite_phy(o_prw, prw)
+       CALL histwrite_phy(o_prlw, prlw)
+       CALL histwrite_phy(o_prsw, prsw)
        CALL histwrite_phy(o_s_pblh, s_pblh)
        CALL histwrite_phy(o_s_pblt, s_pblt)
@@ -938,5 +969,5 @@
              !--STRAT AER
           ENDIF
-          IF (flag_aerosol.GT.0.OR.flag_aerosol_strat) THEN
+          IF (flag_aerosol.GT.0.OR.flag_aerosol_strat.GT.0) THEN
 !             DO naero = 1, naero_spc
 !--correction mini bug OB
@@ -946,5 +977,5 @@
              END DO
           ENDIF
-          IF (flag_aerosol_strat) THEN
+          IF (flag_aerosol_strat.GT.0) THEN
              CALL histwrite_phy(o_tausumaero_lw, &
                   tausum_aero(:,6,id_STRAT_phy) )
@@ -1032,4 +1063,8 @@
        CALL histwrite_phy(o_zfull,zphi/RG)
 
+       IF (flag_aerosol_strat.EQ.2) THEN
+         CALL histwrite_phy(o_stratomask, stratomask)
+       ENDIF
+      
        IF (vars_defined)  THEN
         zx_tmp_fi3d(:,1)= pphis(:)/RG
@@ -1064,7 +1099,24 @@
 
        CALL histwrite_phy(o_dtphy, d_t)
+
        CALL histwrite_phy(o_dqphy,  d_qx(:,:,ivap))
        CALL water_int(klon,klev,d_qx(:,:,ivap),zmasse,zx_tmp_fi2d)
        CALL histwrite_phy(o_dqphy2d,  zx_tmp_fi2d)
+
+       CALL histwrite_phy(o_dqlphy,  d_qx(:,:,iliq))
+       CALL water_int(klon,klev,d_qx(:,:,iliq),zmasse,zx_tmp_fi2d)
+       CALL histwrite_phy(o_dqlphy2d,  zx_tmp_fi2d)
+
+       IF (nqo.EQ.3) THEN
+       CALL histwrite_phy(o_dqsphy,  d_qx(:,:,isol))
+       CALL water_int(klon,klev,d_qx(:,:,isol),zmasse,zx_tmp_fi2d)
+       CALL histwrite_phy(o_dqsphy2d,  zx_tmp_fi2d)
+       ELSE 
+       zx_tmp_fi3d=0.0
+       CALL histwrite_phy(o_dqsphy,  zx_tmp_fi3d)
+       zx_tmp_fi2d=0.0
+       CALL histwrite_phy(o_dqsphy2d,  zx_tmp_fi2d)
+       ENDIF
+
        DO nsrf=1, nbsrf
           IF (vars_defined) zx_tmp_fi2d(1 : klon) = falb1( 1 : klon, nsrf)
@@ -1103,7 +1155,17 @@
        CALL histwrite_phy(o_clwcon, clwcon0)
        CALL histwrite_phy(o_dtdyn, d_t_dyn)
+
        CALL histwrite_phy(o_dqdyn, d_q_dyn)
-       CALL water_int(klon,klev,d_q_dyn,zmasse,zx_tmp_fi2d)
-       CALL histwrite_phy(o_dqdyn2d,zx_tmp_fi2d)
+
+       CALL histwrite_phy(o_dqdyn2d,d_q_dyn2d)
+
+       CALL histwrite_phy(o_dqldyn, d_ql_dyn)
+
+       CALL histwrite_phy(o_dqldyn2d, d_ql_dyn2d)
+
+       CALL histwrite_phy(o_dqsdyn, d_qs_dyn)
+
+       CALL histwrite_phy(o_dqsdyn2d, d_qs_dyn2d)
+
        CALL histwrite_phy(o_dudyn, d_u_dyn)
        CALL histwrite_phy(o_dvdyn, d_v_dyn)
Index: /LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90	(revision 2542)
@@ -64,4 +64,8 @@
       REAL, ALLOCATABLE, SAVE :: t_ancien(:,:), q_ancien(:,:)
 !$OMP THREADPRIVATE(t_ancien, q_ancien)
+      REAL, ALLOCATABLE, SAVE :: ql_ancien(:,:), qs_ancien(:,:)
+!$OMP THREADPRIVATE(ql_ancien, qs_ancien)
+      REAL, ALLOCATABLE, SAVE :: prw_ancien(:), prlw_ancien(:), prsw_ancien(:)
+!$OMP THREADPRIVATE(prw_ancien, prlw_ancien, prsw_ancien)
       REAL, ALLOCATABLE, SAVE :: u_ancien(:,:), v_ancien(:,:)
 !$OMP THREADPRIVATE(u_ancien, v_ancien)
@@ -441,4 +445,6 @@
       ALLOCATE(rugoro(klon))
       ALLOCATE(t_ancien(klon,klev), q_ancien(klon,klev))
+      ALLOCATE(ql_ancien(klon,klev), qs_ancien(klon,klev))
+      ALLOCATE(prw_ancien(klon), prlw_ancien(klon), prsw_ancien(klon))
       ALLOCATE(u_ancien(klon,klev), v_ancien(klon,klev))
 !!! Rom P >>>
@@ -601,7 +607,9 @@
       deallocate(zthe, zpic, zval)
       deallocate(rugoro, t_ancien, q_ancien, clwcon, rnebcon)
+      deallocate(qs_ancien, ql_ancien)
+      deallocate(prw_ancien, prlw_ancien, prsw_ancien)
       deallocate(qtc_cv,sigt_cv)
-      deallocate(        u_ancien, v_ancien                 )
-      deallocate(        tr_ancien)                           !RomP
+      deallocate(u_ancien, v_ancien)
+      deallocate(tr_ancien)                           !RomP
       deallocate(ratqs, pbl_tke,coefh,coefm)
 !nrlmd<
